#!flask/bin/python
from flask import Flask, session, redirect, url_for, render_template, request, make_response, jsonify
from forms import LoginForm
import requests
import sys
import json,urllib2

#this code manages how backend controls chat operations
#Initially, this code was though so that worked as a chat without frontend, only backend
#This code will be merged with backend.py to avoid problems and delete informations that are no longer relevant

#initialize constructor and config secret key to save session
#TODO: delete this secret key because it is unecessary
app = Flask(__name__)
app.config['SECRET_KEY'] = 'gjr39dkjn344_!67#'

#save session user to make operations
#TODO: delete this because it is unecessary
global session_user
global users

#show initial page from chat
#if a GET request was made, it is sent a csrf_token, corresponding to session
#this is deprecated and will be deleted because session will stored in a different manner
#TODO: delete this method because page initial will be only in frontend
@app.route('/', methods=['GET','POST'])
def index():
    """"Login form to enter a room."""
    form = LoginForm()
    if form.validate_on_submit():
        session['name'] = form.name.data
        session['room'] = form.room.data
        return redirect(url_for('.chat'))
    elif request.method == 'GET':
        form.name.data = session.get('name', '')
        form.room.data = session.get('room', '')
  	return session.get('csrf_token'),200
    #Workarounds: delete it too
    else:
	session['name'] = request.json['name']
        session['room'] = request.json['room']
	return redirect('.chat'),201
    return render_template('index.html', form=form)

#method that save user in room and allows it send messages to users that are in
@app.route('/chat', methods=['GET','POST'])
def chat():
    #this method receives JSON from frontend
    #this JSON has user information as name, room that it entered and token
    if(request.method == 'POST'):
    	session[u'name'] = request.json['name']
    	session[u'room'] = request.json['room']
	session[u'csrf_token'] = request.json['csrf_token']
	global session_user
	session_user={}
	session_user[u'name'] = request.json['name']
        session_user[u'room'] = request.json['room']
        session_user[u'csrf_token'] = request.json['csrf_token']
	#we create user and room JSON to send to backend
	#this will be merged with backend.py
    	user={
		'name':session_user[u'name'],
		'room': session_user[u'room'],
		'color':'#9C9C9C',
		'ip':'10.0.0.1',
		'session_id':request.json['csrf_token']
}
	room={
		'name':session_user[u'room'],
		'messages': [],
		'users': [session_user[u'name']]
}	
	#sends to backend.py the user data
	req_user = urllib2.Request("http://localhost:5000/users")
	req_user.add_header('Content-Type','application/json')
	response_user = urllib2.urlopen(req_user,json.dumps(user))

	#sends to backend.py room information
	req_room = urllib2.Request("http://localhost:5000/rooms")
        req_room.add_header('Content-Type','application/json')
        response_room = urllib2.urlopen(req_room,json.dumps(room))

    name = session.get('name', '')
    room = session.get('room', '')
    if name == '' or room == '':
        return redirect(url_for('.index'))
    #GET method would serve when this code worked both frontend as backend
    #How only backend is necessary, it will be deleted
    if(request.method == 'GET'):
	return render_template('chat.html',room=room), 201
    #in a POST request, this method return the room created with informations of users that are in
    else:
	return jsonify(json.loads(response_room.read())), 201

#starts the service
if __name__ == '__main__':
  app.run(debug=True,host='0.0.0.0', port=5050)
